from threading import Thread

class mergesort():
	def __init__(self, l):
		self.array = l
	
	def sort(self,start,end):
		if end-start < 2 :
			return
		else :
			t1 = Thread(target=mergesort.sort,args=(self,start,start+(end-start)/2))
			t2 = Thread(target=mergesort.sort,args=(self,start+(end-start)/2,end))
			t1.start()
			t2.start()
			t1.join()
			t2.join()
			self.array[start:end]=merge(self.array[start:start+(end-start)/2], self.array[start+(end-start)/2:end])
	
	def __call__(self):
		self.sort(0,len(self.array))
		return self.array
		

def merge(front, back):
	result = []
	while front and back:
		if front[0]<back[0] :
			result += [front.pop(0)]
		else :
			result += [back.pop(0)]
	return result + front + back
				
def sort(array):
  if len(array) <= 1: return array
  mid = len(array)/2
  return merge(sort(array[:mid]), sort(array[mid:]))

if __name__ == '__main__' :
	i = [ 1,3,5,2,4,6 ]
	print i
	print sort(i)
	print i
	x = mergesort(i)
	print x()
	
